<?php

namespace Modules\Target\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Product\Services\ProductService;
use Modules\Target\Enums\TargetLengthEnum;
use Modules\Target\Services\TargetService;
use Modules\User\Enums\UserRoleEnum;

class EditTargetRequest extends FormRequest
{
    public function __construct(
        private ProductService $productService,
        private TargetService $targetService,
    ){}
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::admins();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('tags'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $target = $this->targetService->getItem($this->route('target') ?? 0 );
        if($target)
        {
            if($target->lock)
            {
                return [
                    'locked'=>'required'
                ];
            }
        }
        $statuses = TargetLengthEnum::values();
        $rules =
        [
            'target'=>
            [
                'required',
                'numeric',
                'min:0'
            ]
        ];


        return $rules;
    }
    public function messages()
    {
        return [
            'locked.required'=>__('dashboard.locked'),
        ];
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'target'=>__('targets.target'),
        ];

        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
